package edu.cmu.qatar._15121.hw4;

import java.util.ArrayList;

public class MyLinkedList<DataType> {

    private class ListNode {
        private DataType data;
        private ListNode next;

        public ListNode(DataType data) {
            this.data = data;
            this.next = null;
        }

        public String toString() {
            return data.toString();
        }
    }

    private ListNode head;
    private int size;

    public MyLinkedList() {
        head = null;
        size = 0;
    }

    public void addHead(DataType value) {
        ListNode newNode = new ListNode(value);
        newNode.next = head;
        head = newNode;
        size++;
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("List Contents: ");
        for (ListNode tmpNode = head; tmpNode != null; tmpNode = tmpNode.next) {
            sb.append(tmpNode);
            sb.append(" --> ");
        }
        sb.append("<null>");
        return sb.toString();
    }

    public int size() {
        return size;
    }

    public boolean isEmpty() {
        return head == null;
    }

    public void clear() {
        ListNode tmpNode = head;
        while (tmpNode != null) {
            ListNode t = tmpNode.next;
            tmpNode.data = null;
            tmpNode.next = null;
            tmpNode = t;
        }

        head = null;
        size = 0;
    }

    public boolean contains(DataType value) {
        for (ListNode tmpNode = head; tmpNode != null; tmpNode = tmpNode.next) {
            if (tmpNode.data.equals(value)) {
                return true;
            }
        }
        return false;
    }

    public DataType get(int index) {
        int i = 0;
        for (ListNode tmpNode = head; tmpNode != null; tmpNode = tmpNode.next) {
            if (i == index) {
                return tmpNode.data;
            }
            i++;
        }

        throw new java.lang.IndexOutOfBoundsException("Index: " + index + ", Size: " + size);
    }

    public int indexOf(DataType value) {
        int i = 0;
        for (ListNode tmpNode = head; tmpNode != null; tmpNode = tmpNode.next) {
            if (tmpNode.data.equals(value)) {
                return i;
            }
            i++;
        }
        return -1;
    }

    public void add(DataType value) {
        if (isEmpty()) {
            addHead(value);
        } else {
            ListNode tmpNode = head;
            while (tmpNode.next != null) {
                tmpNode = tmpNode.next;
            }
            tmpNode.next = new ListNode(value);
            size++;
        }
    }

    public boolean remove(DataType value) {
        // Special cases
        if (isEmpty()) {
            return false;
        } else if (head.data.equals(value)) {
            head.data = null;
            head = head.next;
            size--;
            return true;
        }

        // General case
        for (ListNode tmp = head; tmp.next != null; tmp = tmp.next) {
            if (tmp.next.data.equals(value)) {
                tmp.next = tmp.next.next;
                size--;
                return true;
            }
        }
        return false;
    }

    /*
     * New Functions are below here.
     */

    public DataType remove(int index) {
        return null;
    }

    public DataType set(int index, DataType newValue) {
        return null;
    }

    public int lastIndexOf(DataType value) {
        return -1;
    }

    public void add(int index, DataType value) {

    }

    // Must be O(N) or better
    public void add(ArrayList<DataType> arr) {

    }

    public boolean removeLastOccurrence(DataType target) {
        return false;
    }

    // Must be O(N) or better
    public void removeAll(DataType value) {

    }

    // Must be O(N) or better
    public MyLinkedList<DataType> clone() {
        return null;
    }

    /*
     * This getter is needed for the autograder, don't change or remove it.
     */
    public ListNode getHead() {
        return head;
    }
}
